"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var streamToString = require("stream-to-string");
var constants_1 = require("../../utils/constants");
var contentTypePatterns_1 = require("../../utils/contentTypePatterns");
var parseJSON_1 = require("../../utils/parseJSON");
var jsonStartPattern = /^\{|\[|\".*\"$|[0-9]+$|true$|false$/i;
exports.default = function (_a) {
    var stream = _a.stream, contentType = _a.contentType;
    return __awaiter(_this, void 0, void 0, function () {
        var data, dataIsJson, content;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!contentTypePatterns_1.jsonContentTypePattern.test(contentType)) return [3 /*break*/, 2];
                    return [4 /*yield*/, streamToString(stream)];
                case 1:
                    data = _b.sent();
                    dataIsJson = jsonStartPattern.test(data);
                    if (dataIsJson) {
                        content = parseJSON_1.default(data, ['content']);
                        return [2 /*return*/, { content: content, contentType: constants_1.jsonContentType }];
                    }
                    else {
                        return [2 /*return*/, { content: data, contentType: constants_1.textContentType }];
                    }
                    _b.label = 2;
                case 2: return [2 /*return*/, { content: undefined, contentType: contentType }];
            }
        });
    });
};
//# sourceMappingURL=getContent.js.map